<script setup lang="ts">
  definePageMeta({
    layout: 'presentation',
    middleware: 'guide-auth-guard',
  });
  const { currentSlide, stateLoaded, slidesCount } = usePresentation();
  const { controlledClient } = useParticipants();
  const { loadLikeList, getLikeListStatistics } = useLikeList();
  const { refreshCart, getAllCarts } = useCart();
  const { loadBookmarkIds } = useBookmark();
  const { lastClientChangedLikes } = usePresentationState();

  onMounted(() => {
    loadBookmarkIds();
  });

  watch(
    controlledClient,
    async () => {
      if (controlledClient.value) {
        await Promise.all([loadLikeList(), refreshCart()]);
      } else {
        await Promise.all([getLikeListStatistics(), getAllCarts()]);
      }
    },
    {
      immediate: true,
    },
  );

  watchDebounced(
    lastClientChangedLikes,
    () => {
      if (!controlledClient.value) {
        getLikeListStatistics();
      } else if (lastClientChangedLikes.value?.changedBy === controlledClient.value.attendeeId) {
        loadLikeList();
      }
    },
    { debounce: 2000 },
  );
</script>
<template>
  <div class="relative min-h-full py-4 md:py-10">
    <DynamicPagesContainer />

    <CmsPage
      v-if="currentSlide?.cmsPageResult?.cmsPage"
      :key="`${currentSlide?.groupId}-${currentSlide?.sectionId}-${currentSlide?.pickedProductsCount}`"
      :content="currentSlide.cmsPageResult?.cmsPage"
      :options="currentSlide"
      type="presentation"
    />

    <SwLoading
      v-else-if="!(slidesCount === 0 && stateLoaded)"
      :class="['text-primary absolute left-1/2 top-1/2 -translate-x-1/2 -translate-y-1/2 text-3xl']"
    />
  </div>
</template>
